diff --git a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
index c0a1ff409..cc7e6e520 100644
--- a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
@@ -424,10 +424,6 @@ public class PlayerServer extends Player implements ContainerListener {
         }
     }
 
-    public void func_22068_s()
-    {
-    }
-
     @Override
 	public EnumSleepStatus sleepInBedAt(int x, int y, int z)
     {
@@ -741,7 +737,7 @@ public class PlayerServer extends Player implements ContainerListener {
     @Override
     public void fling(final double xd, final double yd, final double zd, final float pushTime) {
         super.fling(xd, yd, zd, pushTime);
-        this.playerNetServerHandler.sendPacket(new PacketMovePlayer.PosRot(this.x, this.y + 1.625, this.z, this.yRot, this.xRot, false));
+        this.playerNetServerHandler.sendPacket(new PacketMovePlayer.PosRot(this.x, this.y, this.z, this.yRot, this.xRot, false));
         this.playerNetServerHandler.sendPacket(new PacketEntityFling(this.id, this.xd, this.yd, this.zd, this.pushTime, this.pushesThisTick));
     }
 
diff --git a/game/server/src/main/java/net/minecraft/server/net/PlayerList.java b/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
index d7689c58f..8495a5036 100644
--- a/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
+++ b/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
@@ -249,7 +249,6 @@ public class PlayerList
         worldserver.entityJoinedWorld(newPlayer);
         playerEntities.add(newPlayer);
         newPlayer.setupCraftingInventoryListener();
-        newPlayer.func_22068_s();
         newPlayer.playerNetServerHandler.sendPacket(new PacketGameRule(server.getDimensionWorld(0).getLevelData().getGameRules()));
         return newPlayer;
     }
diff --git a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
index 5db443aa2..1c2d2615f 100644
--- a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
@@ -127,14 +127,10 @@ public class PacketHandlerServer extends PacketHandler
 
         if (!hasMoved)
         {
-            double dx = packet.x - lastPosX;
-            double dy = packet.y - lastPosY;
-            double dz = packet.z - lastPosZ;
-            dx *= dx;
-            dy *= dy;
-            dz *= dz;
-            if (dx * dx < 0.01D && dy * dy < 0.01D && dz * dz < 0.01D)
-            {
+            double dx = packet.x - playerEntity.x;
+            double dy = packet.y - playerEntity.y;
+            double dz = packet.z - playerEntity.z;
+            if (dx * dx > 0.01D || dy * dy > 0.01D || dz * dz > 0.01D) {
                 hasMoved = true;
             }
         }
@@ -208,7 +204,7 @@ public class PacketHandlerServer extends PacketHandler
             {
                 //kickPlayer("Illegal position");
                 LOGGER.warn("{} tried to move to an illegal position", playerEntity.username);
-                teleportAndRotate(lastPosX, lastPosY, lastPosZ, yRot, xRot);
+                teleport(lastPosX, lastPosY, lastPosZ);
                 return;
             }
         }
@@ -229,13 +225,13 @@ public class PacketHandlerServer extends PacketHandler
         {
             // This doesn't mean they are necessarily hacking, it's easy to do by hitting the vanilla speed limit
             LOGGER.warn("{} moved too quickly!", playerEntity.username);
-            teleportAndRotate(lastPosX, lastPosY, lastPosZ, yRot, xRot);
+            teleport(lastPosX, lastPosY, lastPosZ);
             //kickPlayer("You moved too quickly :( (Hacking?)");
             return;
         }
         // Time to trying and move like they did
         float bb_expand = 0.0625F;
-        boolean insideBlockOld = worldserver.getCubes(playerEntity, playerEntity.bb.copy().getInsetBoundingBox(bb_expand, bb_expand, bb_expand)).isEmpty();
+        boolean insideBlockOld = worldserver.getCubes(playerEntity, playerEntity.bb.copyPooled().getInsetBoundingBox(bb_expand, bb_expand, bb_expand)).isEmpty();
         playerEntity.move(dx, dy, dz);
         // Get the difference in intended move and actual move
         dx = newPosX - playerEntity.x;
@@ -252,7 +248,7 @@ public class PacketHandlerServer extends PacketHandler
             LOGGER.warn("Expected {}, {}, {}", playerEntity.x, playerEntity.y, playerEntity.z);
         }
         playerEntity.absMoveTo(newPosX, newPosY, newPosZ, yRot, xRot);
-        boolean insideBlockNew = worldserver.getCubes(playerEntity, playerEntity.bb.copy().getInsetBoundingBox(bb_expand, bb_expand, bb_expand)).isEmpty();
+        boolean insideBlockNew = worldserver.getCubes(playerEntity, playerEntity.bb.copyPooled().getInsetBoundingBox(bb_expand, bb_expand, bb_expand)).isEmpty();
         if (playerEntity.pushTime < 0.1f && !playerEntity.getGamemode().canPlayerFly() && insideBlockOld && (movedWrong || !insideBlockNew) && !playerEntity.isPlayerSleeping())
         {
             // If the player:
@@ -260,12 +256,12 @@ public class PacketHandlerServer extends PacketHandler
             // - Moved wrongly
             // - And is not sleeping or flying
             // Bounce them back
-            teleportAndRotate(lastPosX, lastPosY, lastPosZ, yRot, xRot);
+            teleport(lastPosX, lastPosY, lastPosZ);
             return;
         }
 
         // Falling and ground collision
-        AABB aabb = playerEntity.bb.copy().grow(bb_expand, bb_expand, bb_expand).expand(0.0D, -0.55D, 0.0D);
+        AABB aabb = playerEntity.bb.copyPooled().grow(bb_expand, bb_expand, bb_expand).expand(0.0D, -0.55D, 0.0D);
         if (!playerEntity.getGamemode().canPlayerFly() && !mcServer.allowFlight && !worldserver.getIsAnySolidGround(aabb))
         {
             // Don't tick fly counter if they are falling
@@ -300,7 +296,7 @@ public class PacketHandlerServer extends PacketHandler
 		lastPosY = y;
 		lastPosZ = z;
 		playerEntity.absMoveTo(x, y, z, playerEntity.yRot, playerEntity.xRot);
-		playerEntity.playerNetServerHandler.sendPacket(new PacketMovePlayer.Pos(x, y + 1.625, z, false));
+		playerEntity.playerNetServerHandler.sendPacket(new PacketMovePlayer.Pos(x, y, z, false));
 	}
 
 	public void teleportAndRotate(double x, double y, double z, float yaw, float pitch) {
@@ -309,7 +305,7 @@ public class PacketHandlerServer extends PacketHandler
 		lastPosY = y;
 		lastPosZ = z;
 		playerEntity.absMoveTo(x, y, z, yaw, pitch);
-		playerEntity.playerNetServerHandler.sendPacket(new PacketMovePlayer.PosRot(x, y + 1.625, z, yaw, pitch, false));
+		playerEntity.playerNetServerHandler.sendPacket(new PacketMovePlayer.PosRot(x, y, z, yaw, pitch, false));
 	}
 
     @Override
diff --git a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
index dcea78b96..063497fa0 100644
--- a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -42,9 +42,9 @@ public class WorldServer extends World
     public List<TileEntity> getBlockEntitiesWithinBounds(int minX, int minY, int minZ, int maxX, int maxY, int maxZ)
     {
         ArrayList<TileEntity> arraylist = new ArrayList<>();
-        for(int i = 0; i < loadedTileEntityList.size(); i++)
+        for(int i = 0; i < tileEntityList.size(); i++)
         {
-            TileEntity tileEntity = loadedTileEntityList.get(i);
+            TileEntity tileEntity = tileEntityList.get(i);
             if(tileEntity.x >= minX && tileEntity.y >= minY && tileEntity.z >= minZ && tileEntity.x < maxX && tileEntity.y < maxY && tileEntity.z < maxZ)
             {
                 arraylist.add(tileEntity);
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoader.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoader.java
index 4de727b4c..63a922170 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoader.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoader.java
@@ -3,6 +3,7 @@ package org.useless.seedviewer.bta.worldloader;
 import com.mojang.logging.LogUtils;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.NbtIo;
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.World;
@@ -10,10 +11,7 @@ import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkLoaderLegacy;
 import net.minecraft.core.world.chunk.EmptyChunk;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
-import net.minecraft.core.world.chunk.reader.ChunkReader;
-import net.minecraft.core.world.chunk.reader.ChunkReaderLegacy;
-import net.minecraft.core.world.chunk.reader.ChunkReaderVersion1;
-import net.minecraft.core.world.chunk.reader.ChunkReaderVersion2;
+import net.minecraft.core.world.chunk.reader.*;
 import net.minecraft.core.world.save.mcregion.RegionFileCache;
 import net.minecraft.core.world.type.WorldTypes;
 import org.useless.seedviewer.collections.ChunkLocation;
@@ -89,6 +87,7 @@ public class ChunkLoader implements IChunkProvider {
         chunk.isTerrainPopulated = reader.getIsTerrainPopulated();
         chunk.temperature = reader.getTemperatureMap();
         chunk.humidity = reader.getHumidityMap();
+        chunk.tickList = reader.getTickList();
         Int2ObjectMap<String> biomeRegistry = reader.getBiomeRegistry();
 
         for(int i = 0; i < Chunk.CHUNK_SECTIONS; ++i) {
@@ -110,6 +109,10 @@ public class ChunkLoader implements IChunkProvider {
             Arrays.fill(chunk.humidity, Double.NEGATIVE_INFINITY);
         }
 
+        if (chunk.tickList == null) {
+            chunk.tickList = new Int2ObjectArrayMap<>();
+        }
+
         return chunk;
     }
     private static ChunkReader getChunkReaderByVersion(CompoundTag tag, int version) {
@@ -118,6 +121,8 @@ public class ChunkLoader implements IChunkProvider {
                 return new ChunkReaderVersion1(null, tag);
             case 2:
                 return new ChunkReaderVersion2(null, tag);
+            case 3:
+                return new ChunkReaderVersion3(null, tag);
             default:
                 return new ChunkReaderLegacy(null, tag);
         }
